#if   DSQUALSPEED == 1 
  #define DSQUAL  0x1F  // 0x1F  9     ~93.75 
  #define DSSPEED 5
#elif DSQUALSPEED == 2 
  #define DSQUAL  0x3F  // 0x3F 10     ~187.5
  #define DSSPEED 9
#elif DSQUALSPEED == 3 
  #define DSQUAL  0x5F  // 0x5F 11     ~375 
  #define DSSPEED 18
#elif DSQUALSPEED == 4 
  #define DSQUAL  0x7F  // 0x7F 12     ~750
  #define DSSPEED 40
#endif
#ifndef BYTE                      // 
#define BYTE unsigned char
#endif
#ifndef RBYTE					  //   
#define RBYTE register BYTE
#endif

typedef prog_uchar FBYTE;           //   FLASH 
typedef prog_char FCHAR;            //   FLASH 

#if HD4780 == 162

//-------- 
#define sch_DB4     PORTC_Bit2      //   4    
#define DDR_DB4     2       // 
#define sch_DB5     PORTC_Bit3      //  4    
#define DDR_DB5     3       // 
#define sch_DB6     PORTC_Bit4      //  4    
#define DDR_DB6     4       // 
#define sch_DB7     PORTC_Bit5      //  4    
#define DDR_DB7     5       // 
#define DDR_DATA    DDRC

//-------- 
#define sch_RS      PORTB_Bit3      //  /   RS
#define DDR_RS      3       // 
#define sch_RW      PORTB_Bit4      //    / RW
#define DDR_RW      4       // 
#define sch_E       PORTB_Bit5      //      E
#define DDR_E       5       // 
#define DDR_CONTROL DDRB
//--------         0-3  0  4-6  1  ....
char Strsorce [3*SORCE]; 
char rpm_str  [5];
char Servo_str[4];
#endif


struct CarbSmart{
	   unsigned int mServoMax ;     //    0-
	   unsigned int mServoCenter ;  //    1- 
	   unsigned int mServoMin ;     //    2-
	   BYTE Direction;	            //    0/1 CarbSmart
	   unsigned int Carbsmart_tempr;//   CarbSmart ( 0)
	   BYTE Carbsmart_start;        //   
}CarbSmart,* pCarbSmart;

EEMEM struct CarbSmart eCarbSmart={        //    
									2000,  //   
                                    1450,  //   
									 800,  //   
									   0,  //   
					     (OVERHEAT_0<<4),  //    
							     CSSTART   //      
									   }; 
volatile struct CarbSmartControl
  {
  BYTE                      // 
  t1:1,                     //      0  
  t2:1,                     //    1  1       
  rpm:1,                    //      
  CsE:1,                   // Carbsmart  = 1.
  thE:1,                   //   = 1
  GvE:1;                   //   =1.
  }CsC;
  
									   
float Therm[SORCE];  //    .
#if HD4780 == 162
unsigned int irq_Flag1_1; //      clock/1024/256
unsigned char TCNT2_ovf;  //  2      16
#endif
#if HD4780 == 162
void btoar(unsigned int,char *);
#endif
void init_PWM(void) ;
int  main(void);



