//    
#if HD4780 == 162
  eeprom_read_block( &V2,&Ftempl5, 16);
	fv.t= 1;
	fv.s1=1;
	fv.h= 0;       						 //      
	while(!fv.h){wdt_reset();}          //      
	c_templ=5;
#endif
 PORTD |=0xE0;     //      
  _delay_ms(1000);  //      1  
  PORTD &=0x1F;
  bool Setup=0;
  while (PIND_Bit4)
  {
    wdt_reset();
    _delay_us(210);
	if ( ADC>=0x1FF) Setup = 1;
	else Setup = 0;
    if (Setup){
  	  V2[6]= 'S';
	  V2[7]= 'o';
	  V2[8]= 'r';
	  V2[9]= 'c';
	  V2[10]='e';
    }
    else {
  	  V2[6]= 'm';
	  V2[7]= 'a';
	  V2[8]= 'i';
	  V2[9]= 'n';
	  V2[10]=32;
	}
    fv.s1=1;		  
    fv.h= 0;
    while(!fv.h){wdt_reset();}          //      
	
  }
if (Setup)  
{                                   
#if HD4780 == 162
    eeprom_read_block( &V2,&Ftempl2, 32);
  //  for(BYTE j=0; j<32; j++)V2[j]=pgm_read_byte(&Ftempl2[j]); //    
	fv.t= 1;
	fv.s1=1;
    fv.s2=1;		  
	fv.h= 0;       						 //      
	while(!fv.h){wdt_reset();}          //      
	c_templ=2;
#endif
  BYTE i=0;
  for (;i<SORCE;i++) //   2 
  {
    union ROM_Union RomUnion;
    while (PIND_Bit4) wdt_reset(); //   
	if (DSInit())                  //   
	{
	  TxByte(0x33); //   
	  if (GetRomCode(&RomUnion))
	  {  //       
	     // c      
		 //       .
	  #if HD4780 == 162
		     //     6   
	     V2[6]=48+i;
		 //        
		 for (BYTE j=0;j<8;j++)
		 { 
			char tmpStr[2];
            itoa(RomUnion.Bytes[j],tmpStr,16);  //   
			V2[LCD_W+j*2]=tmpStr[0];            //     
			V2[LCD_W+1+j*2]=tmpStr[1];
		 }
		 for(BYTE j=16;j<32;j++) if(!V2[j])V2[j]='0';
		 fv.t= 1;
         fv.s1=1;		  
         fv.s2=1;		  
	     fv.h= 0;
		 while(!fv.h){wdt_reset();}          //      
		 #endif
		 if (CompareROMCodes(&RomUnion, &Flash_ROM_Union[i]))
		 {
		   eeprom_write_block(&RomUnion,&Flash_ROM_Union[i],8);
		 }
	  }
	}
	
	PORTD |= (1<<(i+5)); //          
	_delay_ms(1000);
  }
  while (PIND_Bit4) wdt_reset(); //    
}
else {
  
  unsigned int AD_Data=CarbSmart.mServoCenter;
#if HD4780 == 162
    eeprom_read_block( &V2,&Ftempl4, 16);
 //   for(BYTE j=0; j<16; j++)V2[j]=pgm_read_byte(&Ftempl4[j]); //     
	for(BYTE j=16; j<32; j++)V2[j]=32;
	fv.t= 1;
	fv.s1=1;
    fv.s2=1;		  
	fv.h= 0;       						 //     
	while(!fv.h){wdt_reset();}          //      
	c_templ=4;
#endif
	_delay_ms(500);
  while (PIND_Bit4) //  
  {
     wdt_reset();
     _delay_us(210);
	 PORTD &=0b00011111;
	 PORTB &=0b11111110;
     if (ADC < 0xFF) 
	 {
	   PORTB |=1;
	   CarbSmart.Carbsmart_tempr=35;  //       35 100 110  120  .
	 }
	 if (ADC>=0xFF && ADC<0x1FF)
	 {
       PORTD |=0b00100000;
	   CarbSmart.Carbsmart_tempr=100;
	 }
     if (ADC>=0x1FF && ADC<0x2FF)
	 { 
	   PORTD |=0b01000000;
	   CarbSmart.Carbsmart_tempr=110;
	 }
	 if (ADC>=0x2FF && ADC<0x3FF) 
     {
	   PORTD |=0b10000000;
	   CarbSmart.Carbsmart_tempr=120;
	 }
#if HD4780 == 162
    for(BYTE j=0;j<3;j++) V2[j+10]=32;
//    btoar((CarbSmart.Carbsmart_tempr&0x00FF),&V2[10]);
    char tmpStr[3];
	itoa(CarbSmart.Carbsmart_tempr,tmpStr,10);  //   
	BYTE zz;
	if (CarbSmart.Carbsmart_tempr<100) zz=1;
	else zz=0;
    for(BYTE j=0;(j+zz)<3;j++) V2[j+10]=tmpStr[j]; 
	fv.t= 1;
	fv.s1=1;
	fv.h= 0;       						 //    
	while(!fv.h){wdt_reset();}          //    
	c_templ=3;
#endif

  }
  CarbSmart.Carbsmart_tempr=(CarbSmart.Carbsmart_tempr<<4);
  _delay_ms(1000);
#if HD4780 == 162
    eeprom_read_block( &V2,&Ftempl3, 32);
 //   for(BYTE j=0; j<32; j++)V2[j]=pgm_read_byte(&Ftempl4[j]);; //    
	fv.t= 1;
	fv.s1=1;
	fv.h= 0;       						 //    
	while(!fv.h){wdt_reset();}          //    
	c_templ=3;
#endif
  for (BYTE jj=0;jj<4;jj++)
  {
#if HD4780 == 162
    if (jj==0){
  	  V2[26]='m';
	  V2[27]='a';
	  V2[28]='x';
    }
    if (jj==1){
	  V2[26]='c';
	  V2[27]='e';
	  V2[28]='n';
	  V2[29]='t';
	  V2[30]='r';
    }
    if (jj==2){
	  V2[26]='m';
	  V2[27]='i';
	  V2[28]='n';
	  V2[29]=32;
	  V2[30]=32;
    }
    if (jj==3){
	  V2[26]='r';
	  V2[27]='i';
	  V2[28]='c';
	  V2[29]='h';
    }
  	fv.t= 1;
	fv.s2=1;
	fv.h= 0;       						 //    
	while(!fv.h){wdt_reset();}          //    	
#endif
    while (PIND_Bit4) // CarbSmart
    {
      wdt_reset();
      _delay_us(210);
      if (jj==0) AD_Data=2100 - ( ADC>>1 );
      if (jj==1) AD_Data=1196 + ( ADC>>1 );
	  if (jj==2) AD_Data=CarbSmart.mServoCenter -  ( ADC>>1 );
	  if (jj==3) AD_Data=CarbSmart.mServoMin +  ADC ;
      OCR1B=AD_Data;  
    }
    if (jj==0) CarbSmart.mServoMax=AD_Data;
    if (jj==1) CarbSmart.mServoCenter=AD_Data;
    if (jj==2) CarbSmart.mServoMin=AD_Data;  
    if (jj==3)
    {
      if ( AD_Data > CarbSmart.mServoCenter) CarbSmart.Direction = 1;
	  else CarbSmart.Direction = 0;
    }
    _delay_ms(1000);
  }
  eeprom_write_block(pCarbSmart,&eCarbSmart,10);
}
