//------------------------------------------------------------------------------ 
//     :
// -     2 .
//
// -       RW, RS, E   .
// -       V1[]       
//    0,   7812,5   .=128 .
// -       :
//                 7   6    5    4   3   2   1   0
//                [T] [RW] [RS] [E] [7] [6] [5] [4]
//   > T -    ,   7 (+0 ) -       
//   > RW - 1-, 0- ( 0),         .
//   > RS - 0- , 1-  (.    )
//   > E -    (1- )
//   > [7] [6] [5] [4] -     
//
// -   -   8     
//    HD44780,            
//        (     )  
//     
//        204 V2[80].          
//        .
// -            V2[]=>V1[]
//
// -            
//    (   ,    ).
//
//             ,  
//       -    .
//------------------------------------------------------------------------------ 
//     :
// -     2 .
//
// -       RW, RS, E   .
// -       V1[]       
//    0,   7812,5   .=128 .
// -       :
//                 7   6    5    4   3   2   1   0
//                [T] [RW] [RS] [E] [7] [6] [5] [4]
//   > T -    ,   7 (+0 ) -       
//   > RW - 1-, 0- ( 0),         .
//   > RS - 0- , 1-  (.    )
//   > E -    (1- )
//   > [7] [6] [5] [4] -     
//
// -   -   8     
//    HD44780,            
//        (     )  
//     
//        204 V2[80].          
//        .
// -            V2[]=>V1[]
//
// -            
//    (   ,    ).
//
//             ,  
//       -    .
//        .
//------------------------------------------------------------------------------ 
//       
#define BLINK_ON     0x0d        //  -  
#define LINE_ON      0x0e        //  -  
#define CUR_OFF      0x0c        //  

#define LCD_H        2
#define LCD_W        16

volatile BYTE V1[8];                    //    
volatile BYTE iV1=0;                    //      
volatile BYTE nV1=0;                    //     
volatile BYTE wV1=0;                    //       

//  ""       .
char V2[37] = {0x30, 0x30, 0x30, 0x20, 0x28, 0x06, 0x0e, 0x01, 'L', 'o', 'a', 'd', 'i', 'n', 'g', '.', '.', '.'};

volatile BYTE iV2=0;                    //    
volatile BYTE nV2=18;                   //     
volatile BYTE aV2;                      //   
volatile BYTE lV2;                      //          :
//                 
// ,           
volatile BYTE fc=0xff;
// fc=255    -   CUR_OFF
// 7b=1      -   BLINK_ON
// 7b=0      -   LINE_ON
// 10b       -    
// 65432b    -    

volatile struct VideoControl
  {
  BYTE                      // ,     
  s1:1,                     //    0  ()
  s2:1,                     //    1       
  d:1,                      //         0-, 1-
  t:1,                      // 0 -           
                            // 1 -     
  h:1;                      // 0 -      (   )
                            // 1 -      (    )
  }fv;
//------------------------------------------------------------------------------ 
//   V2    
volatile BYTE c_templ=0;  //   
char templ1[32];
#include "template.h"