ISR (TIMER1_OVF_vect)
{
//------------------------------
    if (!PIND_Bit4)  //   Carbsmart
  {
    _delay_ms(200);
	if (!PIND_Bit4) CsC.CsE = ~CsC.CsE;
  }
//------------------------------  
  static BYTE counter;
  if (counter == DSSPEED+8) counter=0;
//------------------------------
  if (counter ==0)  //       
  {
    if (DSInit())
    {
      TxByte(0xCC);
      TxByte(0x44);
    }
  }
//------------------------------
  if (counter == DSSPEED) 
  {	 //        () ()  ()
	for (BYTE i=0; i<SORCE; i++)
	{
	  if (DSInit())
	  {
	 	TxByte(0x55); //    2  
		for (BYTE y=0;y<8;y++)
		{
		  TxByte(FlashROM[i].Bytes[y]);
		}
		TxByte(0xBE);
		ReadScratchpad(&ScratchPad[i]);
		if (fDS.CRCErr==0)fDS.DsReady=1;
	  }
	}
  }
//------------------------------  
counter++;  
  if (counter == DSSPEED+2)  
  {
//-------           float
    char x=0;
	for (BYTE i=0;i<SORCE;i++)
    {
      wdt_reset();
	  x=(ScratchPad[i].Scratchpad.Tempr[1]<<4) | (ScratchPad[i].Scratchpad.Tempr[0]>>4); //    
	  float y=(float)(ScratchPad[i].Scratchpad.Tempr[0]&0x0F)/(float)(16.); //    
	  Therm[i]=(float)x+y; //   .
    } 
//--------------------------------------------------------------------------------------
//-------     
//--------------------------------------------------------------------------------------
    PORTD&=0b00011111;
    if (Therm[0]>OVERHEAT_0 )  PORTD_Bit0= ~PORTD_Bit0; //     
    else PORTD_Bit0=0;   
//--------------------------------------------------------------------------------------
	if (Therm[0]<0) PORTD_Bit7 = 1;  //     0
    else PORTD_Bit7 = 0;  
  }
//------------------------------  
  if (counter == DSSPEED+4)  
  {  
//--------------------------------------------------------------------------------------
//-------            
//--------------------------------------------------------------------------------------
#if HD4780 == 162 //        ,      	
	for (BYTE i=0;i<SORCE;i++)
	{
      wdt_reset();
	  char y[SORCE];
	  static char z[SORCE];
	  for(BYTE j=0;j<3;j++) Strsorce[j+i*3]=32; //   
	  y[i]=Therm[i];             //       
	  if (y[i]>128 && y[i]<255) //      "-"   
	  {
	    y[i] = ~y[i];
		Strsorce[i*3]='-';
	  }
	  if(!y[i]==z[i])
	  {
	    if (i==0)CsC.t1=1; //    
		if (i==1)CsC.t2=1;
	  }
	  btoar((unsigned int)y[i],&Strsorce[i*3]);
	} 
#endif
  if (CsC.thE)
  {  //  /  /
     // 60/(irq_Flag1_1*  /)
	 //60/( x * 1/62.5kHz(16us))  irq_Flag1_1  1048560  
	 // 60 /  !
	  unsigned int rpm =3750000/irq_Flag1_1;
	  btoar(rpm,rpm_str);
      CsC.rpm =1;
  }

	if ( CsC.CsE )  
	{
	  #if SORCE > 0
	  #include "carbsmart.h"
	  #endif
	  PORTB_Bit0=  ~PORTB_Bit0 ; //    
    }
	else  //          
    {
      OCR1B = CarbSmart.mServoCenter;
      PORTD|=0b11100000;
	}
#if HD4780 == 162
	 //----------        
	 //   -   100%
	 //   -    -100%
	 for(BYTE j=0;j<4;j++) Servo_str[j]=32; //   
     unsigned int yy=0;
	 if (OCR1B>CarbSmart.mServoCenter)
	 {
	   yy= (OCR1B - CarbSmart.mServoCenter) /((float)(CarbSmart.mServoMax-CarbSmart.mServoCenter)/100);
	   if (CarbSmart.Direction) Servo_str[0]='-';
	 }
	 if (OCR1B<CarbSmart.mServoCenter)
	 {
	   yy= (CarbSmart.mServoCenter - OCR1B) /((float)(CarbSmart.mServoCenter-CarbSmart.mServoMin)/100);
	   if (!CarbSmart.Direction)Servo_str[0]='-';
	 }
	 btoar(yy,&Servo_str[1]);
#endif		
  }
#if HD4780 == 162
  if (fv.h)
  { 
	  //------------------//
	  //|EtttC Servo xxx%|//
	  //|AtttC  RRRRR rpm|//
	  //------------------//
    if (c_templ == 1)
    {
//-------  
      if (CsC.t1)
	  {
	    for(BYTE j=0; j<3; j++)V2[j+1]=Strsorce[j];         //   1
	    CsC.t1=0;
		for(BYTE j=0; j<4; j++)V2[j+11]=Servo_str[j];        //   
	    fv.s1=1;  //    1
	  }
//-------  
      if(CsC.t2 || CsC.rpm)
	  {
        #if SORCE > 1	  
	      for(BYTE j=0; j<3; j++)V2[j+1+LCD_W]=Strsorce[j+3]; //   2
		  CsC.t2=0;
	    #endif
	    for(BYTE j=0; j<5; j++)V2[j+7+LCD_W]=rpm_str[j]; //  
		CsC.rpm =0;
		fv.s2=1;  //    2
      }
	  fv.t=1;   //    
      fv.h=0;   //      
	  }
    }
#endif	   
}
//-----------   
ISR (INT1_vect)
{ 
#if HD4780 == 162
  irq_Flag1_1=(TCNT2_ovf<<8)+TCNT2;
  TCNT2=0;
  TCNT2_ovf=0;
#endif  
}
ISR (TIMER2_OVF_vect)
{
#if HD4780 == 162
  TCNT2_ovf++;
#endif
}
//-----------        
ISR (TIMER0_OVF_vect)
{
  #if HD4780 == 162
    BYTE register x, y=0;
    #include "hd4780_16x2.c"
  #endif 
}